#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "../buffer.h"

void print(sockev_buffer_t *bu)
{
	const char *b;
	int len;
	char str[1024];
	if (sockev_buffer_get(bu, &b, &len) == 0) {
		memcpy(str, b, len);
		str[len] = '\0';
	}
	else
		strcpy(str,"<empty>");

	printf("* TOTAL: %d first: '%s'\n", sockev_buffer_total(bu), str);
}

void appstr(sockev_buffer_t *bu, char *str)
{
	sockev_buffer_append(bu, str, strlen(str));
	print(bu);
}

void peek(sockev_buffer_t *bu, int max)
{
	const char *b;
	int len, l;
	char str[1024];

	if (sockev_buffer_get(bu, &b, &len) < 0) {
		printf("peek: <empty>\n");
		return;
	}

	l = max;
	if (len < max)
		l = len;
	memcpy(str, b, l);
	str[l] = '\0';

	printf("peek: max=%d len=%d '%s'\n", max, len, str);
	sockev_buffer_remove(bu, l);
	print(bu);
}

int main()
{
	sockev_buffer_t b;

	sockev_buffer_init(&b);
	print(&b);
	appstr(&b, "hello");
	appstr(&b, "world");
	appstr(&b, "through buffer");
	peek(&b, 1024);
	peek(&b, 2);
	peek(&b, 2);
	peek(&b, 2);
	peek(&b, 3);
	peek(&b, 11);
	peek(&b, 1024);
	return 0;
}
